# Class CLN1SectionReadableImageCube

java.lang.Object
com.io7m.calino.vanilla.internal.CLN1SectionReadableAbstract
com.io7m.calino.vanilla.internal.CLN1SectionReadableImageCube

All Implemented Interfaces:
  `CLNSectionReadableImageCubeType, CLNSectionReadableStandardType, CLNSectionReadableType, Closeable, AutoCloseable`

public final class CLN1SectionReadableImageCube extends CLN1SectionReadableAbstract implements CLNSectionReadableImageCubeType
A readable cube image section.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SeekableByteChannel`
  `mipMapDataRaw(CLNImageCubeDescription description)`
  Obtain a readable channel that returns potentially compressed data.
  `ReadableByteChannel`
  `mipMapDataWithoutSupercompression(CLNImageCubeDescription description)`
  Obtain a readable channel that returns decompressed data (that is, data with any supercompression removed).
  `List<CLNImageCubeDescription>`
  `mipMapDescriptions()`

  ### Methods inherited from class CLN1SectionReadableAbstract

  `close, description, errorLimitExceeded, fileSectionDescription, reader, request, sectionDataChannel`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface CLNSectionReadableType

  `description, fileSectionDescription, sectionDataChannel`

  ### Methods inherited from interface Closeable

  `close`

- ## Method Details

  - ### mipMapDescriptions

    public List<CLNImageCubeDescription> mipMapDescriptions() throws IOException
    Specified by:
      `mipMapDescriptions` in interface `CLNSectionReadableImageCubeType`
    Returns:
      The set of declared mipmaps
    Throws:
      `IOException` - On errors

  - ### mipMapDataWithoutSupercompression

    public ReadableByteChannel mipMapDataWithoutSupercompression(CLNImageCubeDescription description) throws IOException
    Description copied from interface: `CLNSectionReadableImageCubeType`
    Obtain a readable channel that returns decompressed data (that is, data with any supercompression removed).
    Specified by:
      `mipMapDataWithoutSupercompression` in interface `CLNSectionReadableImageCubeType`
    Parameters:
      `description` - The image description
    Returns:
      A readable channel
    Throws:
      `IOException` - On I/O errors

  - ### mipMapDataRaw

    public SeekableByteChannel mipMapDataRaw(CLNImageCubeDescription description) throws IOException
    Description copied from interface: `CLNSectionReadableImageCubeType`
    Obtain a readable channel that returns potentially compressed data. The bytes returned by the channel are not interpreted in any form, and are exactly as they appeared in the underlying file.
    Specified by:
      `mipMapDataRaw` in interface `CLNSectionReadableImageCubeType`
    Parameters:
      `description` - The image description
    Returns:
      A readable channel
    Throws:
      `IOException` - On I/O errors